unit AdvanceStringCore;
interface
uses sharemem,windows,classes,sysutils,graphics,forms,AdvanceStringTypes;
TYPE

TTokenExtractMode = AdvanceStringTypes.TTokenExtractMode;
                    {(extractUntilNumber,extractuntilspace,ExtractUntilLetter,extractFixedLength
                     ,ExtractUntilSpecificChar,ExtractUNtilSpecificString
                     ,ExtractUntilNotLetter,ExtractUntilNotAlpha,ExtractUntilNotNumber);}
TTokenExtractSet = AdvanceStringTypes.TTokenExtractSet;//Set Of TTokenExtractMode;

     FString = AdvanceStringTypes.FString;// String[255];
     LString = AdvanceStringTypes.LString;// String[128];
     TString = AdvanceStringTypes.TString;// String[32];
TStringArray = AdvanceStringTypes.TStringArray; //Array of String;
        Tslp = AdvanceStringTypes.tslp;//^TstringList;
    TStringp = AdvanceStringTypes.TStringP;// ^string;
     PString = AdvanceStringTypes.PString;//^Fstring;

                          //*************************************************
                          //**       DOCUMENT PAGINATION CONTROLS          **
                          //*************************************************
                          TPageSplitter = Class
                          private
                                 Pages:TList; // of TStringList
                                 FPageSeperator:String;
                                 FIncludeBreakInCompiledPages:BOOLEAN;

                                 Function CountPages:Integer;

                          public

                                Property PageSeperator:String read FPageSeperator write FPageSeperator;
                                // The default is #12
                                Property IncludeBreakInCompiledPages:Boolean read FIncludeBreakInCompiledPages write FIncludeBreakInCompiledPages;
                                //the Default is True
                                // IF true the PageSeperator string is always included in line[0] of the generated stringlist

                                Property PageCount:Integer read CountPages;


                                Function GetPage(PageNo:Integer;IncludeBreak:Boolean; Var ToList:TStringList):Boolean; overload;
                                Function GetPage(PageNo:Integer;IncludeBreak:Boolean):TStringList;Overload;
                                Function GetPage(PageNo:Integer):TStringList; overload;

                                Function AbsoluteCombinePages(PageList:String;var ToList:TStringList):Boolean;overload;
                                Function AbsoluteCombinePages(PageList:String):TStringList;overload;
                                //the pages to be combined are listed as distinct comma-seperated values
                                // ie 1,2,1,5,3

                                Function CombinePages(PageString:String; var ToList:TStringList):Boolean;overload;
                                Function CombinePages(PageString:String):TStringList;overload;
                                // This function parses the page string in order to generate the pagelist
                                // for instance 1,2..5,3..6,8,12

                                procedure clear;

                                Procedure ParseSourceDocument(Source:TStringList); overload;
                                Procedure ParseSourceDocument(SourceFile:TFilename); overload;

                                constructor create;
                                destructor destroy; override;

                          end;


                          //**************************************************
                          //**     WRITE OUT THE BITMAP TO A TEXT SOURCE    **
                          //**************************************************
                          TBitmapDump = class
                          private
                                 FImage:TBitmap;
                                 FDump:TStringlist;

                                 Procedure CreateDump;
                                 Procedure CreateBitmap;

                          public

                                Property Dump:TStringList read FDump;
                                Property Image:TBitmap read FImage;

                                Procedure Assign(Source:TBitmap);overload;
                                Procedure Assign(Source:TObject);overload;
                                Procedure Assign(Source:TStringList);overload;

                                procedure clear;

                                constructor create;
                                destructor destroy;
                          end;



CONST
     nul = '';
     space=' ';
     endline= #10;
     feedline =#13;
     LeftArrow  = #75;
     RightArrow = #77;
     uparrow = #72;
     DownArrow = #80;
     _UFAnyNumeric = #1; //#
     _UFAnyAlpha = #6;   //%
     _UFAnyLengthOfNumerics = #2; //^
     _UFAnyLengthOfAlphas = #3;  //$
     _UFAnyLengthOfAlphaNumerics = #4; //
     _UFAnyAlphaNumeric = #5; // 
     _UFAnyNumericNS = #7; //#
     _UFAnyAlphaNS = #8;   //%
     _UFAnyLengthOfNumericsNS = #9; //^
     _UFAnyLengthOfAlphasNS = #10;  //$
     _UFAnyLengthOfAlphaNumericsNS = #11; //
     _UFAnyAlphaNumericNS = #12; // 


VAR _GrammarRules:TStringList;
    _SpellingRules:TStringList;
    _CountryList:TStringList;

//********************************************************************************************************
//********************************************************************************************************
//**                               ADD STRINGS TO PROFILE                                               **
//********************************************************************************************************
//********************************************************************************************************
PROCEDURE AddStringsToProfile(SS:TStringList;OpenBlock,CLoseBlock:String;data:TStringList;comment:char);  stdcall; external 'AdvanceStringCore.dll';
// Insert the string [data] to the specified profile


//********************************************************************************************************
//********************************************************************************************************
//**                                 ALPHA SORT                                                         **
//********************************************************************************************************
//********************************************************************************************************
PROCEDURE AlphaSort(s1,s2:string;VAR n1,n2:String);  stdcall; external 'AdvanceStringCore.dll';
// Returns in n1 and n2,  s1 and s1 in ascending alphabeical order


//********************************************************************************************************
//********************************************************************************************************
//**                            ARRANGE STRINGS TO  FIELDS                                              **
//********************************************************************************************************
//********************************************************************************************************
Function ArrangeStringsToFields(CONST s:String;CONST  fieldDef:String;CONST SepChar:Char):string;  stdcall; external 'AdvanceStringCore.dll';
//"Hello 1         lachlan"," #         !        !"
//                          " Hello     1  Lachlan")
// # = Left Format ! = Right Align * = Center

//********************************************************************************************************
//********************************************************************************************************
//**                             BOOLEAN TO STRING                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION BooleanToStr(Const b:boolean):String;  stdcall; external 'AdvanceStringCore.dll';
// returns the Strings True or False

//********************************************************************************************************
//********************************************************************************************************
//**                               BUILD RGB                                                            **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION BuildRGB(Const rgbstring:string):integer;  stdcall; external 'AdvanceStringCore.dll';
// create a colour value from a r,g,b formatted string

//********************************************************************************************************
//********************************************************************************************************
//**                  CAPITALISE ALL WORDS IN A SENTENCE                                                **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CapitaliseAllWordsInSentence(Const S:String; Const SepChar: CHAR):String;  stdcall; external 'AdvanceStringCore.dll' name 'CapitaliseAllWordsInSentance';
// takes every word in a sentence >> Takes Every Word In A Sentence

//********************************************************************************************************
//********************************************************************************************************
//**                              CAPITALISE SENTENCE                                                   **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CapitaliseSentence(Const S:String;CONST SepChar:Char):String;  stdcall; external 'AdvanceStringCore.dll' name 'CapitaliseSentance';
//'tAkes A SEntence' >> 'Takes a sentrnce'

//********************************************************************************************************
//********************************************************************************************************
//**                             CAPITALISE STRING                                                      **
//********************************************************************************************************
//********************************************************************************************************
Function CapitaliseString(Const S:String):String;  stdcall; external 'AdvanceStringCore.dll';
//LaChLAN >> Lachlan

//********************************************************************************************************
//********************************************************************************************************
//**                                 CHOP                                                               **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ChopA(CONST source:STRING;CONST mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
FUNCTION ChopB(Const source:string):String;  stdcall; external 'AdvanceStringCore.dll';
FUNCTION Chop(CONST source:STRING;CONST mask:CHAR):STRING; overload;
FUNCTION Chop(Const source:string):String;overload;
// removes mask from either end of the list so chopping '_' from _hello___ = hello

//********************************************************************************************************
//********************************************************************************************************
//**                                 CHOP AWAY                                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION chopAway(CONST source:STRING;CONST mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
// calls chop  - Retained for backwards compatibility

//********************************************************************************************************
//********************************************************************************************************
//**                                     CHOP SET                                                       **
//********************************************************************************************************
//********************************************************************************************************
Function ChopSet(Const source,mask:string):string;  stdcall; external 'AdvanceStringCore.dll';
// as with standard chop but can trim an array of characters at once

//********************************************************************************************************
//********************************************************************************************************
//**                                 CHOP SINGLE                                                        **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ChopSingle(CONST source:STRING;CONST mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
// removes only one from each end so chooping '_' from _hello__ = hello_

//********************************************************************************************************
//********************************************************************************************************
//**                           COMMA SEPERATE FLOAT                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CommaSeperateFloat(F:DOUBLE):String;  stdcall; external 'AdvanceStringCore.dll';
// 1000000.000000 = 1,000,000.000000

//********************************************************************************************************
//********************************************************************************************************
//**                         COMMA SEPERATE INTEGER                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CommaSeperateInteger(I:Integer):String;  stdcall; external 'AdvanceStringCore.dll';
// 1000000 = 1,000,000

// ******************************************************************
// **               CONCURRENT MATCHING CHAR ELEMENTS              **
// ******************************************************************
Function ConcurrentCountMatchingCharElements
         (const SourceChars,MaskChars:String
         ;Const CSensitive:Boolean):Integer;  stdcall; external 'AdvanceStringCore.dll';
// Return the number of times [mask[i]] and [source[i]]
// characters match

//********************************************************************************************************
//********************************************************************************************************
//**                     COUNT INSIDE PINCER SUBSTRINGS                                                 **
//********************************************************************************************************
//********************************************************************************************************
function countInsidePincerSubstrings(source:string;pinceropen:string;pincerclose:string):integer;  stdcall; external 'AdvanceStringCore.dll';
// counts the number of strings within the pincers

//********************************************************************************************************
//********************************************************************************************************
//**                                 COUNT MASK                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CountMask(CONST S:String;CONST mask:Char):Longint;  stdcall; external 'AdvanceStringCore.dll';
// Returns the number of occurances of [mask] in [s]

// ******************************************************************
// **               COUNT MATCHING CHAR ELEMENTS                   **
// ******************************************************************
Function CountMatchingCharElements(const SourceChars,MaskChars:String
                                  ;Const CSensitive:Boolean):Integer;  stdcall; external 'AdvanceStringCore.dll';
// Return the simple number of [mask] characters that occur within
// the string [source].  'HELLO','HL' >> 3

//********************************************************************************************************
//********************************************************************************************************
//**                         COUNT OUTSIDE PINCEER SUBSTRINGS                                           **
//********************************************************************************************************
//********************************************************************************************************
function countOutsidePincerSubstrings(source:string;pinceropen:string;pincerclose:string):integer;  stdcall; external 'AdvanceStringCore.dll';
// counts the number of strings outside the pincers

//********************************************************************************************************
//********************************************************************************************************
//**                            COUNT PRIOR CHARACTERS                                                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CountPriorCharacters(CONST Slist:TstringList;CONST CaretPos:Tpoint):INTEGER;  stdcall; external 'AdvanceStringCore.dll';
//returns to total number of characters in a [string list] up to caratpos
// use for collecting selindex value

//********************************************************************************************************
//********************************************************************************************************
//**                           COUNTRY CODE TO NAME                                                     **
//********************************************************************************************************
//********************************************************************************************************
function CountryCodeToName(Const Code:String):String;  stdcall;  external 'AdvanceStringCore.dll';
// takes a country code held in [coutrylist] and retreves the full name

//********************************************************************************************************
//********************************************************************************************************
//**                           COUNT STRINGS                                                            **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CountStrings(CONST Source,M:String;CONST SepChar:Char):INTEGER;  stdcall; external 'AdvanceStringCore.dll';
// returns the number of times [mask] appears in source

//********************************************************************************************************
//********************************************************************************************************
//**                              COUNT SUBSTRING                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CountSubstring(CONST source:STRING;CONST mask:CHAR):WORD;  stdcall; external 'AdvanceStringCore.dll';
// counts the number of mask seperated words in string

//********************************************************************************************************
//********************************************************************************************************
//**                             COUNT SUBSTRING WITH ARRAY MASK                                        **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION CountSubStringWithArrayMask(CONST Source:String;CONST mask:String):Integer;  stdcall; external 'AdvanceStringCore.dll';
// counts the number of mask seperated words in string

//********************************************************************************************************
//********************************************************************************************************
//**                              DEEP LOCATE WORD                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION DeepLocateWord(mask,source:STRING;sep:CHAR;rset:STRING):WORD;  stdcall; external 'AdvanceStringCore.dll';
// returns the index of the word [mask] in source or 0 for a fail
// as above but strips any characters within rset from the current
// word. (so mask:hello would be found in the string hello & hello+rset
// providing rset isnt one of the seperating characters
// set rset[end] as the sep character to avoid this problem

//********************************************************************************************************
//********************************************************************************************************
//**                             ENSURE EXTENSION                                                       **
//********************************************************************************************************
//********************************************************************************************************
Function EnsureExtension(Const Source,Extension:String):String;  stdcall; external 'AdvanceStringCore.dll';
// Ensure that a filename has the desired file extension

//********************************************************************************************************
//********************************************************************************************************
//**                         ENSURE TRAILING BACK SLASH                                                 **
//********************************************************************************************************
//********************************************************************************************************
Function EnsureTrailingBackSlash(CONST S:String):String;  stdcall; external 'AdvanceStringCore.dll';
// Ensures that [s] ends with a backslash

//********************************************************************************************************
//********************************************************************************************************
//**                          ENSURE TRAILING CHARACTER                                                 **
//********************************************************************************************************
//********************************************************************************************************
Function EnsureTrailingCharacter(CONST S:String;const c:char):String;  stdcall; external 'AdvanceStringCore.dll';
// Ensures that [s] ends with the character [c]

//********************************************************************************************************
//********************************************************************************************************
//**                            EXTRACT PROFILE BLOCK                                                   **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ExtractProfileBlock(slist:TStringlist;BlockOpen,BlockClose:String):TStringList;  stdcall; external 'AdvanceStringCore.dll';
//Load a profile section from text file
// [Profile Open]
//     data
//     [Sub Section]
//      somedata
//     [Sub Section Close]
// [Profile Close]


//********************************************************************************************************
//********************************************************************************************************
//**                            EXTRACT REMAINDER                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION extractRemainder(CONST source:String;CONST from:word):String;  stdcall; external 'AdvanceStringCore.dll';
// extract all the character from [from] to the end or [s]

//********************************************************************************************************
//********************************************************************************************************
//**                              EXTRACT REMAINDER ARRAY STOP WITH OFFSET                              **
//********************************************************************************************************
//********************************************************************************************************
Function ExtractRemainderArrayStopWithOffsetA(Const Source:String;Var Offset:Integer; Const MaskSet:Array Of String; MaskCount:Integer):String;  stdcall; external 'AdvanceStringCore.dll';
Function ExtractRemainderArrayStopWithOffsetB(Const Source:String;Var Offset:Integer; Const MaskSet:TstringList):String;  stdcall; external 'AdvanceStringCore.dll';
Function ExtractRemainderArrayStopWithOffset(Const Source:String;Var Offset:Integer; Const MaskSet:Array Of String; MaskCount:Integer):String;  overload;
Function ExtractRemainderArrayStopWithOffset(Const Source:String;Var Offset:Integer; Const MaskSet:TstringList):String; overload;
//Extracts until [end] or until one of the mask characters is met
//returns the index within [source] of the stop condition

//********************************************************************************************************
//********************************************************************************************************
//**                            EXTRACT REMAINDER STOP                                                  **
//********************************************************************************************************
//********************************************************************************************************
Function ExtractRemainderStop(CONST source:string;CONST from:WORD;CONST exitc:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
// extracts the remainder of the string but stops if exitc is found
// useful for having end of line commenting

//********************************************************************************************************
//********************************************************************************************************
//**                             EXTRACT TOKEN                                                          **
//********************************************************************************************************
//********************************************************************************************************
Function ExtractToken(Const Source:String; Var Offset:integer; ExtractMode:TTokenExtractSet;LParam:Integer;SParam:String):String;  stdcall; external 'AdvanceStringCore.dll';
//from an offset postion within [source] this function will extract a number of characters
//for as long as those characters meet the ExtractMode pattern

//********************************************************************************************************
//********************************************************************************************************
//**                                 FIND IN LIST                                                       **
//********************************************************************************************************
//********************************************************************************************************
function FindInList(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean;
                    Const IgnoreSpaces:Boolean; Const ScanMode:Char;const matchfrom:integer):String; overload;
function FindInList(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean; Const IgnoreSpaces:Boolean; Const ScanMode:Char):String; overload;
function FindInListA(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean;
                    Const IgnoreSpaces:Boolean; Const ScanMode:Char;const matchfrom:integer):String;  stdcall; external 'AdvanceStringCore.dll';
function FindInListB(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean; Const IgnoreSpaces:Boolean; Const ScanMode:Char):String;  stdcall; external 'AdvanceStringCore.dll';
// [he] [hello, heli, beta], false,true,'A' , 2 = 'heli'
// 'A' = scan across, 'S' = sum bytes , 'P' = [source] must be a substring of an element in [wordlist]


//********************************************************************************************************
//********************************************************************************************************
//**                             FIND NEXT MASK                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION FindNextMask(Source:String;Spos:Integer;mask:String):INTEGER;  stdcall; external 'AdvanceStringCore.dll';
// Returns the index in the string of the first instance of [mask]
// counting from spos

//********************************************************************************************************
//********************************************************************************************************
//**                               FIND STRING IN LIST                                                  **
//********************************************************************************************************
//********************************************************************************************************
Function FindStringInList(slist:TStringList;mask:string;comment:char):TPOINT;  stdcall; external 'AdvanceStringCore.dll';
//returns to coords of a string within a stringlist

//********************************************************************************************************
//********************************************************************************************************
//**                            FLOAT TO WORDS                                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION FloatToWords(Const f:Double):String;  stdcall; external 'AdvanceStringCore.dll';
// 1,000,000.24456 := One million point two, four, four, five, six.

//********************************************************************************************************
//********************************************************************************************************
//**                            FORCE STRING TO LENGTH                                                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ForceStringLength(Const S:String; Const Newlength:integer):String;  stdcall; external 'AdvanceStringCore.dll';
// Forces a string to the new length fills itself out with spaces'

//********************************************************************************************************
//********************************************************************************************************
//**                            FORCE STRING MAX LENGTH                                                 **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ForceStringMaxLength(S:String;max:longint):String;  stdcall; external 'AdvanceStringCore.dll';
//prevents a string from exceeeding max characters

//********************************************************************************************************
//********************************************************************************************************
//**                           GENDER TO CODE                                                           **
//********************************************************************************************************
//********************************************************************************************************
Function GenderToCode(const gstring:string):Char;  stdcall; external 'AdvanceStringCore.dll';
// takes male, m, man, boy, master, mr >> M

//********************************************************************************************************
//********************************************************************************************************
//**                          GET PARAMETER LINE                                                        **
//********************************************************************************************************
//********************************************************************************************************
function getparameterline:string;  stdcall; external 'AdvanceStringCore.dll';
//return the paramstrings for the application

//********************************************************************************************************
//********************************************************************************************************
//**                          GET POINTER TO LETTER                                                     **
//********************************************************************************************************
//********************************************************************************************************
Function GetPointerToLetter(Source:PChar; Const DesiredElement:Integer):PChar;  stdcall; external 'AdvanceStringCore.dll';
//returns a PCHAR pointing to the specifed letter in [source]

//********************************************************************************************************
//********************************************************************************************************
//**                                GET PROFILE VALUE                                                   **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GetProfileValueA(Profile:TstringList;key:string;switch,comment:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
FUNCTION GetProfileValueB(Profile:TStringList;key:string;switch:Char):STRING;  stdcall; external 'AdvanceStringCore.dll';
FUNCTION GetProfileValueC(Profile:TStringList;key:string):STRING;  stdcall; external 'AdvanceStringCore.dll';
FUNCTION GetProfileValue(Profile:TstringList;key:string;switch,comment:CHAR):STRING; overload;
FUNCTION GetProfileValue(Profile:TStringList;key:string;switch:Char):STRING; overload;
FUNCTION GetProfileValue(Profile:TStringList;key:string):STRING; overload;
// Returns keyed data from an excommunicant profile section
// behavies in the same manner as keyed data in an .ini file

//********************************************************************************************************
//********************************************************************************************************
//**                               GET PROGRAM NAME                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GetProgramName(Document:TStringList):String;  stdcall; external 'AdvanceStringCore.dll';
// Returns the name or the pascal unit or program file contained in document

//********************************************************************************************************
//********************************************************************************************************
//**                         GET STRINGLIST AS ARRAY                                                    **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GetStringListAsArray(CONST SL:TStringList):TStringArray;  stdcall; external 'AdvanceStringCore.dll';
// Returns pointers to each line in a string list as an array

//********************************************************************************************************
//********************************************************************************************************
//**                                 GRAB INDEX STRING                                                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabIndexstring(source:String;x1,xL:WORD):STRING;  stdcall; external 'AdvanceStringCore.dll';
// returns [source].x1 .. [source].x1+[source].xl

//********************************************************************************************************
//********************************************************************************************************
//**                                 GRAB SUBSTRING                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabSubstring(s:string;CONST i:Word;CONST mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll' ;
// returns word [i] from [s] where wordss are sperated by [mask]

//********************************************************************************************************
//********************************************************************************************************
//**                              GRAB SUBSTRING WITH ARRAY SEP                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabSubStringWithArraySep(Const S:String; Const I:WORD; Mask:String):String;  stdcall; external 'AdvanceStringCore.dll';
// As with grab substring but with a number of seperating characters

//********************************************************************************************************
//********************************************************************************************************
//**                            GRAB SUBSTRING WITH OFFSET                                              **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabSubstringWithOffset(CONST s:string;CONST i:Word;CONST mask:CHAR;Var Offset:integer):STRING;  stdcall; external 'AdvanceStringCore.dll';
// rreturns word [i] from [s] where wordss are sperated by [mask]
// returns in offset the index of the word in source

//********************************************************************************************************
//********************************************************************************************************
//**                            GRAB SUBSTRING WITH OFFSET WITH ARRAY SEPERATING CHARS                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabSubStringWithOffsetWithArraySep(Const S:String; Const i:Word; Mask:String; VAR Offset:Integer):String;  stdcall; external 'AdvanceStringCore.dll';
// rreturns word [i] from [s] where wordss are sperated by [mask]
// returns in offset the index of the word in source
// alows for a number of vharacters that seperate words

//********************************************************************************************************
//********************************************************************************************************
//**                              GRAB VARIANT SUBSTRING                                                **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabVariantSubstring(s:String;i:Longint;mask:string):String;  stdcall; external 'AdvanceStringCore.dll';
//grabs substring with a number of masks

//********************************************************************************************************
//********************************************************************************************************
//**                                GRAB VL SUBSTRING                                                   **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION GrabVLsubstring(source,exitc:String;from:WORD;VAR final:WORD):STRING;  stdcall; external 'AdvanceStringCore.dll';
// Extract Remainder Stop , [Final] = index of exit character

//********************************************************************************************************
//********************************************************************************************************
//**                                GRAB X STRINGS                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION Grab_X_Strings(Source:STRING;StringCount:integer;mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
//xxx yyy zzz tttt grab_X_strings(s,2,' ') = 'xxx yyy'

//********************************************************************************************************
//********************************************************************************************************
//**                      GRAB X STRING FROM THE END                                                    **
//********************************************************************************************************
//********************************************************************************************************
Function Grab_X_Strings_From_End(source:String;StringCount:Longint;mask:char):string;  stdcall; external 'AdvanceStringCore.dll';
//xxx yyy zzz ttt grab_x_strings_from_ens(s,2,' ') = zzz ttt

//********************************************************************************************************
//********************************************************************************************************
//**                               IN ALPHABETICAL ORDER                                                **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION InAlphabeticalOrder(s1,s2:string):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// Returns true if S2 is greater than S1

//********************************************************************************************************
//********************************************************************************************************
//**                                   IN CHAR LIST                                                     **
//********************************************************************************************************
//********************************************************************************************************
function incharlist(const source:char;const charlist:String):boolean;  stdcall; external 'AdvanceStringCore.dll';
// Inserts a [newstring] into [source] at index [atpos] displaces

//********************************************************************************************************
//********************************************************************************************************
//**                            INCREASE SIZE OF STRING                                                 **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IncreaseSize(Const S:String;Const by:integer; Const WithChar:Char):String;  stdcall; external 'AdvanceStringCore.dll';
// increase the length of a string

//********************************************************************************************************
//********************************************************************************************************
//**                           INDEX OF COUNTRY CODE                                                    **
//********************************************************************************************************
//********************************************************************************************************
function IndexOfCountryCode(Const Code:String):integer;  stdcall; external 'AdvanceStringCore.dll';
// takes a country code held in [coutrylist] and retreves the full name

//********************************************************************************************************
//********************************************************************************************************
//**                           INDEX OF PROFILE LINE                                                    **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IndexOfProfileLine(slist:Tstringlist;closeblock:string):integer;  stdcall; external 'AdvanceStringCore.dll';
// return the line number containing the string [closeblock]

//********************************************************************************************************
//********************************************************************************************************
//**                        INSERT STRING INTO STRING                                                   **
//********************************************************************************************************
//********************************************************************************************************
function InsertStringIntoStringA(const source, newstring:string; Const Atpos:Integer;const fillchr:char):string;  stdcall; external 'AdvanceStringCore.dll';
function InsertStringIntoStringB(const source, newstring:string; Const Atpos:Integer):string;  stdcall; external 'AdvanceStringCore.dll';
function InsertStringIntoString(const source, newstring:string; Const Atpos:Integer;const fillchr:char):string;  overload;
function InsertStringIntoString(const source, newstring:string; Const Atpos:Integer):string; overload;
// Inserts a [newstring] into [source] at index [atpos] displaces
// original letters to the right - will increase the size of the string if [atpost]
// is greater than length([source])

//********************************************************************************************************
//********************************************************************************************************
//**                           INTEGER TO WORDS                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IntegerToWords(CONST i:Integer):STRING;  stdcall; external 'AdvanceStringCore.dll';
// 1,000,000 := One Million

//********************************************************************************************************
//********************************************************************************************************
//**                              IS BUILT FROM                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IsBuiltFrom(source:string;mask:char):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// Does the string ONLY contain mask characters

//********************************************************************************************************
//********************************************************************************************************
//**                           IS CHAR IN MASK SET                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IsCharInMaskSet(Const AChar:Char; CONST maskSet:String):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
//revised convention for charinlist

//********************************************************************************************************
//********************************************************************************************************
//**                               IS INTERSECT                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ISIntersect(source:String;maskset:String;SepChar:CHAR;Csensitive:Boolean):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
//Does [source] equal one of the [maskset] strings - only one elements should be in source

//********************************************************************************************************
//********************************************************************************************************
//**                                IS LETTER                                                           **
//********************************************************************************************************
//********************************************************************************************************
Function IsLetter(Const s:Char):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// a..Z (these characters ONLY)

//********************************************************************************************************
//********************************************************************************************************
//**                                IS MASK AT POSITION                                                 **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION isMaskAtPos(Source:String; Spos:Integer; Mask:STRING):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// does the string [mask] equal the contents of [source] from [spos]

//********************************************************************************************************
//********************************************************************************************************
//**                                 IS NUMBER                                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IsNumber(s:string):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
//Tests to see whether the string can be converted into a number

//********************************************************************************************************
//********************************************************************************************************
//**                               IS STRING MASK                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IsStringMask(CONST source,mask:STRING;CONST from:WORD;CONST Csensitive:BOOLEAN):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// does the mask at source position, from match

//********************************************************************************************************
//********************************************************************************************************
//**                                 IS SUBSTRING                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION IsSubstring(mask,source:STRING):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// SIMPLE version of substring operates from character 1 only


//********************************************************************************************************
//********************************************************************************************************
//**                             JUSTIFY STRING                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION JustifyString(Const s:String;Const size:Integer; Const spaceChar:Char;LCR:CHAR):String;  stdcall; external 'AdvanceStringCore.dll';
// Center,Left, Right align the text within a string lcr = 'L'/'R'/'C'

//********************************************************************************************************
//********************************************************************************************************
//**                                 LIST TO STRING                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ListToString(from:TSLP;fromline:WORD;seperator:Char;ignorespaces:BOOLEAN):STRING;  stdcall; external 'AdvanceStringCore.dll';
// grabs 255 bytes from s string list
// ignores spaces includes Udef line sperator

//********************************************************************************************************
//********************************************************************************************************
//**                              LOCATE MASK POSITION                                                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION LocatemaskPosition(source,mask:STRING;Csensitive:BOOLEAN):WORD;  stdcall; external 'AdvanceStringCore.dll';
// returns the position in the string at which the mask is
// rendered within the source

//********************************************************************************************************
//********************************************************************************************************
//**                                 LOCATE WORD                                                        **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION LocateWORD(mask,source:STRING;sep:CHAR):WORD;  stdcall; external 'AdvanceStringCore.dll';
// returns the index of the word [mask] in source or 0 for a fail

//********************************************************************************************************
//********************************************************************************************************
//**                          MASKED STRING COMPARE                                                     **
//********************************************************************************************************
//********************************************************************************************************
Function MaskedStringCompare(Source,Mask:String):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// '1lachlan@excommunicant.co.uk','#$@$.%%.uk' = true
//  # = Any numeric
//  ^ = Any length of numbers
//  $ = Any length of Alphas
//   = Any length of alphanumerics
//  % = any alphan
//  & = Any Alphanumeric

//*******************************************************************
//**           CONVERT A MONTH TO AN INTEGER                       **
//*******************************************************************
Function MonthToInteger(Month:String):Integer; external 'AdvanceStringCore.dll';
// takes a string containing jan,janurary etc and returns the month
// number.  if the string contains a number already the number is
// validated
// if the string contains an invalid month the function returns 1

//********************************************************************************************************
//********************************************************************************************************
//**                        MOVE STRING BACKWARDS INTO STRING                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION MoveStringBackwardsIntoString(Const Source:String;Const  NewString:String; Const AtPos:integer):String;  stdcall; external 'AdvanceStringCore.dll';
// moves the string [newstring[ into [source] will overwrite existing characters

//********************************************************************************************************
//********************************************************************************************************
//**                      MOVE STRING INTO STRING                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION MoveStringIntoString(Const Source:String;Const NewString:String;Const AtPos:Integer):String;  stdcall; external 'AdvanceStringCore.dll';
// moves the string [newstring[ into [source] will overwrite existing characters

//********************************************************************************************************
//********************************************************************************************************
//**                             NOT COUNT MASK                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION NotCountMask(CONST s:String;Const Mask:CHAR):Integer;  stdcall; external 'AdvanceStringCore.dll';
// Returns the number of non mask Characters in the string

//********************************************************************************************************
//********************************************************************************************************
//**                              NOT INTERSECTION                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION notIntersection(source,mask:STRING):STRING;  stdcall; external 'AdvanceStringCore.dll';
// returns c1 without  c2 (a string masked removemask);
// NOT CASE SENSITIVE

//********************************************************************************************************
//********************************************************************************************************
//**                       PARSE AN EQUATION                                                            **
//********************************************************************************************************
//********************************************************************************************************
function ParseEquationA(EqString:string;var Valid:boolean):string; stdcall; external 'AdvanceStringCore.dll';
function ParseEquationB(EqString:string):string; stdcall; external 'AdvanceStringCore.dll';

function ParseEquation(EqString:string;var Valid:boolean):string; overload;
function ParseEquation(EqString:string):string; overload;
// (100 * (1+1)) >> 200
// Supports the operators *,/,+,-,(,),AND,OR,XOR,NOT,DIV,MOD,SHL,SHR

//********************************************************************************************************
//********************************************************************************************************
//**                             PCHAR TO STRING                                                        **
//********************************************************************************************************
//********************************************************************************************************
Function PCharToStr(Const Sp:PChar):String;  stdcall; external 'AdvanceStringCore.dll';
// actually gives up memory rather than being the pointer copy delphi often does

//********************************************************************************************************
//********************************************************************************************************
//**                       PINCER INSIDE GRABSUBSTRING WITH OFFSET                                      **
//********************************************************************************************************
//********************************************************************************************************
function PincerInsideGrabSubstringWithOffset(source:string; const index:integer; pinceropen:string;pincerclose:string;var offset:integer):string;  stdcall; external 'AdvanceStringCore.dll';
// 'out1 >in1< out2 >in2<',2,'>','<' = 'in2'

//********************************************************************************************************
//********************************************************************************************************
//**                           PINCER INSIDE GRABSUBSTRING                                              **
//********************************************************************************************************
//********************************************************************************************************
function PincerInsideGrabSubstring(source:string; const index:integer; pinceropen:string;pincerclose:string):string;  stdcall; external 'AdvanceStringCore.dll';
// 'out1 >in1< out2 >in2<',2,'>','<' = 'in2'

//********************************************************************************************************
//********************************************************************************************************
//**                             PINCER OUTSIDE GRABSUBSTRING                                           **
//********************************************************************************************************
//********************************************************************************************************
function PincerOutsideGrabSubstring(source:string; const index:integer; pinceropen:string;pincerclose:string):string;  stdcall; external 'AdvanceStringCore.dll';
// 'out1 >in1< out2 >in2<',2,'>','<' = 'out2'

//********************************************************************************************************
//********************************************************************************************************
//**                  PINCER OUTSIDE GRABSUBSTRING WITH OFFSET                                          **
//********************************************************************************************************
//********************************************************************************************************
function PincerOutsideGrabSubstringWithOffset(source:string; const index:integer; pinceropen:string;pincerclose:string;var offset:integer):string;  stdcall; external 'AdvanceStringCore.dll';
// 'out1 >in1< out2 >in2<',2,'>','<' = 'out2'

//********************************************************************************************************
//********************************************************************************************************
//**                 PIXEL FORMAT STRING TO PIXEL FORMAT                                                **
//********************************************************************************************************
//********************************************************************************************************
Function PixelFormatStringToPixelFormat(Const S:String):TPixelFormat;  stdcall; external 'AdvanceStringCore.dll';
// converts a pixelformat string (ie 8bpp) to the pixelformat 8bpp

//********************************************************************************************************
//********************************************************************************************************
//**                                 POSITION                                                           **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION Position(source:string;instance:Longint;mask:Char):Longint;  stdcall; external 'AdvanceStringCore.dll';
//returns the position of the [instance] appearence of [mask] in [source]
//so  position('aaa*aaa*',2,'*') = 7,  <1 = error

//********************************************************************************************************
//********************************************************************************************************
//**                                POSITION STRING                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION PositionString(source:string;instance:Longint;mask:String;sepchar:Char):Longint;  stdcall; external 'AdvanceStringCore.dll';
//returns the position of the [instance] appearence of [mask] in [source]
//so  position('aaa*aaa*',2,'aaa') = 5,  <1 = error

//********************************************************************************************************
//********************************************************************************************************
//**                     PROTECTED GRAB VARIABLE LENGTH SUBSTRING                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION protectedGrabVLString(source:String;from,size:word):STRING;  stdcall; external 'AdvanceStringCore.dll';
// attempts to grab size characters from [source].[from] returns NIl
// if [from]+[size] > length(source);

//********************************************************************************************************
//********************************************************************************************************
//**                          RETRIEVE RELATIVE INDEX OF SUBSTRING                                      **
//********************************************************************************************************
//********************************************************************************************************
Function RelativeIndexOfSubstring(Const Source,Substring:String):Integer;  stdcall; external 'AdvanceStringCore.dll';
// Returns the number of the word [substring] within the sentrnce [source]
// so 'number ' in the above sentence is word 3

//********************************************************************************************************
//********************************************************************************************************
//**                              REMOVE MASK                                                           **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION RemoveMask(CONST s:String;CONST mask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
// returns s without any mask characters, use for removing spaces and things

//********************************************************************************************************
//********************************************************************************************************
//**                              REMOVE MASK SET                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION RemoveMaskSet(CONST s:String;CONST maskSet:String):STRING;  stdcall; external 'AdvanceStringCore.dll';
// returns s without any of the [mask] characters

//********************************************************************************************************
//********************************************************************************************************
//**                       REP REPEAT A CHARACTER                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION Rep(CONST item:CHAR; CONST Amount:WORD):STRING;  stdcall; external 'AdvanceStringCore.dll';
// result = item repeated amount times;

//********************************************************************************************************
//********************************************************************************************************
//**                            REPLACE MASK                                                            **
//********************************************************************************************************
//********************************************************************************************************
Function ReplaceMask(source:string;mask,new:char):String;  stdcall; external 'AdvanceStringCore.dll';
// replacemask('aBaba','B','a') = 'aaaaa'

//********************************************************************************************************
//********************************************************************************************************
//**                          REPLACE MASK SET                                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ReplaceMaskSet(Const S:String;Const MaskSet:String; Const NewChar:Char):STRING;  stdcall; external 'AdvanceStringCore.dll';
// replacemask('aBabCa','Bc','a') = 'aaaaaaa'

//********************************************************************************************************
//********************************************************************************************************
//**                             RETURN ASCII TOTAL                                                     **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ReturnASCIItotal(CONST Source:STRING):WORD;  stdcall; external 'AdvanceStringCore.dll';
// counts all the characters in source and returns the sum of
// their ascii values

//********************************************************************************************************
//********************************************************************************************************
//**                               RETURN KEY FROM LIST                                                 **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION returnKeyfromList(list:TSLP;key:STRING;valchar,stopchar:CHAR;rset:String):string;  stdcall; external 'AdvanceStringCore.dll';
//allows parameters to be grabbed from strings an string lists as a string
//CASE INSENSITIVE
// Made obselete through getprofilevalue

//********************************************************************************************************
//********************************************************************************************************
//**                                 RETURN SWITCH                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ReturnSwitch(source:string;key:String;valmask:char;rset:STRING;cmask:CHAR):STRING;  stdcall; external 'AdvanceStringCore.dll';
//allows parameters to be grabbed from strings an string lists as a string
//CASE INSENSITIVE
// Made obselete through getprofilevalue

//********************************************************************************************************
//********************************************************************************************************
//**                               REVERSE GRAB                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION ReverseGrab(source:STRING;from:WORD;ammount:WORD):STRING;  stdcall; external 'AdvanceStringCore.dll';
// returns (in original order) the characters backwards from [from]
// of source

//********************************************************************************************************
//********************************************************************************************************
//**                               REVERSE ORDER                                                        **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION reverseorder(source:STRING):STRING;  stdcall; external 'AdvanceStringCore.dll';
// reverses the order of the characters in source

//********************************************************************************************************
//********************************************************************************************************
//**                                SPLIT STRING                                                        **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION SplitString(Source:String;SplitChars:ARRAY OF TString):TStringList;  stdcall; external 'AdvanceStringCore.dll';
// hello BEGIN my name END is god
//>> Hello
//   Begin
//   My Name
//   End
//   is god

//********************************************************************************************************
//********************************************************************************************************
//**                                SPLIT STRING LIST                                                   **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION SplitStringList(Source:TStringList;SplitChars:ARRAY OF TString;comment:char):TSTRINGLIST;  stdcall; external 'AdvanceStringCore.dll';
// hello BEGIN my name END is god
//>> Hello
//   Begin
//   My Name
//   End
//   is god

//********************************************************************************************************
//********************************************************************************************************
//**                           STRING INTERSECT                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION StringIntersect(Source:String;MaskSet:String;SepChar:CHAR;Csensitive:Boolean):STRING;  stdcall; external 'AdvanceStringCore.dll';
//Returns the intersect of source and source mask - partitioned by sepchar

//********************************************************************************************************
//********************************************************************************************************
//**                              STRING TO FLOAT                                                       **
//********************************************************************************************************
//********************************************************************************************************
function StringToFloat(const s:String):Double;  stdcall; external 'AdvanceStringCore.dll';
//validates before attempting conversion - defaults result to zero

//********************************************************************************************************
//********************************************************************************************************
//**                             STRING TO INTEGER                                                      **
//********************************************************************************************************
//********************************************************************************************************
function StringToInt(const s:String):integer;  stdcall; external 'AdvanceStringCore.dll';
//validates before attempting conversion - defaults result to zero

//********************************************************************************************************
//********************************************************************************************************
//**                               STRING TO LIST                                                       **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION StringtoList(source:STRING;dest:TSLP;fromLine:WORD;Seperator:CHAR):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// the reverse of listtostring

//********************************************************************************************************
//********************************************************************************************************
//**                          STRIP BLANK LINES                                                         **
//********************************************************************************************************
//********************************************************************************************************
PROCEDURE StripBlankLines(var SList:TStringList);  stdcall; external 'AdvanceStringCore.dll';
// Remove Blank Lines from a StringList

//********************************************************************************************************
//********************************************************************************************************
//**                                STRIP  LINES WITH STRING                                            **
//********************************************************************************************************
//********************************************************************************************************
Procedure StripLinesWithString(Where:TStringList;d:String);  stdcall; external 'AdvanceStringCore.dll';
// remove lines from stringlist that contain the string [d]

//********************************************************************************************************
//********************************************************************************************************
//**                          STRING TO BOOLEAN                                                         **
//********************************************************************************************************
//********************************************************************************************************
Function StrToBoolean(Const s:String):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// turns true >> "True"

//********************************************************************************************************
//********************************************************************************************************
//**                                 SUBSTITURE                                                         **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION Substitute(sourceline,mask,newvalue:STRING):STRING;  stdcall; external 'AdvanceStringCore.dll';
// replaces the mask text within sourceline with newvalue
// simply returns the new line of text
// enlarges the string if newvalueis> length than mask
// reduces if newvalue  is < length of mask
// only overwrites characters given by mask

//********************************************************************************************************
//********************************************************************************************************
//**                            SUBSTITUTE IN STRING LIST                                               **
//********************************************************************************************************
//********************************************************************************************************
PROCEDURE substituteInStringList(from:TSLP;mask,newvalue:STRING);  stdcall; external 'AdvanceStringCore.dll';
// as with subsiture but searchs for the data through a stringlist

//********************************************************************************************************
//********************************************************************************************************
//**                                 SUBSTRING                                                          **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION substring(mask,source:STRING;VAR offset:WORD):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// is mask represented within the range of source from offset
// NOT CASE SENSITIVE
// offset gets adjusted to show the index withing source where mask begins

//********************************************************************************************************
//********************************************************************************************************
//**                                TRECT STRING TO TRECT                                               **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION TRectStringToTrect(Const S:String):TRect;  stdcall; external 'AdvanceStringCore.dll';
// '10,10,20,20' creates a TRect with these dimensions

//********************************************************************************************************
//********************************************************************************************************
//**                               TRECT TO STRING                                                      **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION TrectToStr(T:Trect):String;  stdcall; external 'AdvanceStringCore.dll';
// (x1,y1,x2,y2)

//********************************************************************************************************
//********************************************************************************************************
//**                    UNFRIENDLY MASKED STRING COMPARE                                                **
//********************************************************************************************************
//********************************************************************************************************
Function UNFRIENDLYMaskedStringCompare(Source,Mask:String):BOOLEAN;  stdcall; external 'AdvanceStringCore.dll';
// '1lachlan@excommunicant.co.uk','#$@$.%%.uk' = true
//  # = Any numeric
//  ^ = Any length of numbers
//  $ = Any length of Alphas
//   = Any length of alphanumerics
//  % = any alphan
//  & = Any Alphanumeric
// AS with MaskedStringCompare exect the UF_ constants are used in place
// of the chracter tokens above so 'aba'+UF_AnyAlpha+'somemoretext

//********************************************************************************************************
//********************************************************************************************************
//**                                 UPPER CASE STRING                                                  **
//********************************************************************************************************
//********************************************************************************************************
FUNCTION upcaseString(CONST s:String):STRING;  stdcall; external 'AdvanceStringCore.dll';
// turn all characters into their uppercase equivalent

implementation

function ParseEquation(EqString:string;var Valid:boolean):string; overload;
begin
     result := parseequationA(eqstring,valid);
end;
function ParseEquation(EqString:string):string; overload;
// (100 * (1+1)) >> 200
// Supports the operators *,/,+,-,(,),AND,OR,XOR,NOT,DIV,MOD,SHL,SHR
begin
     result := parseequationB(eqstring);
end;

function FindInList(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean;
                    Const IgnoreSpaces:Boolean; Const ScanMode:Char;const matchfrom:integer):String; overload;
begin
     Result := FindinListA(Source,Wordlist,CSensitive,IgnoreSpaces,ScanMode,MatchFrom);
end;
function FindInList(Const Source:String; Const Wordlist:TStringList; Const CSensitive:Boolean; Const IgnoreSpaces:Boolean; Const ScanMode:Char):String; overload;
begin
     Result := FindInListB(Source,Wordlist,CSensitive,IgnoreSpaces,Scanmode);
end;

function InsertStringIntoString(const source, newstring:string; Const Atpos:Integer;const fillchr:char):string;  overload;
begin
     Result := InsertStringIntoStringA(Source,NewString,Atpos,FillChr);
end;
function InsertStringIntoString(const source, newstring:string; Const Atpos:Integer):string; overload;
begin
     Result := InsertStringIntoStringB(Source,NewString,AtPos);
end;

Function ExtractRemainderArrayStopWithOffset(Const Source:String;Var Offset:Integer; Const MaskSet:Array Of String; MaskCount:Integer):String;  overload;
begin
     Result := ExtractRemainderArrayStopWithOffsetA(Source,Offset,MaskSet,MaskCount);
end;
Function ExtractRemainderArrayStopWithOffset(Const Source:String;Var Offset:Integer; Const MaskSet:TstringList):String; overload;
begin
     Result := ExtractRemainderArrayStopWithOffsetB(Source,Offset,MaskSet);
end;


FUNCTION GetProfileValue(Profile:TstringList;key:string;switch,comment:CHAR):STRING; overload;
begin
     Result := GetProfileValueA(Profile,Key,Switch,Comment);
end;
FUNCTION GetProfileValue(Profile:TStringList;key:string;switch:Char):STRING; overload;
begin
     Result := GetProfileValueB(Profile,Key,Switch);
end;
FUNCTION GetProfileValue(Profile:TStringList;key:string):STRING; overload;
begin
     Result := GetProfileValueC(Profile,Key);
end;


FUNCTION Chop(CONST source:STRING;CONST mask:CHAR):STRING; overload;
begin
     result := ChopA(Source,Mask);
end;
FUNCTION Chop(Const source:string):String;overload;
begin
     Result := ChopB(Source);
end;


{ TBitmapDump }
//*******************************************************************************************************
//*******************************************************************************************************
//**                                     BITMAP DUMP                                                   **
//*******************************************************************************************************
//*******************************************************************************************************
//*********************************************
//**       ASSIGN FROM A BITMAP DUMP         **
//*********************************************
procedure TBitmapDump.Assign(Source: TObject);
Var
   BD:TBitmapDump;
begin
     Clear;
     if (Source.ClassType <> TBitmapDump) and (Source.ClassParent <> TBitmapDump)  then
     begin
          Application.MessageBox(pchar('Cannot assign a '+String(Source.classname)+' to a TBitmapDump'),'Error',mb_ok);
          exit;
     end;

     BD := TBitmapDump(Source);
     Assign(BD.Image);
end;// Assign from a bitmap dump

//********************************************
//**         ASSIGN FROM A BITMAP           **
//********************************************
procedure TBitmapDump.Assign(Source: TBitmap);
begin
    Clear;
    FImage.Assign(Source);
    CreateDump;
end;
//***********************************************
//**           ASSIGN FROM A DUMP SOURCE       **
//***********************************************
procedure TBitmapDump.Assign(Source: TStringList);
begin
     Clear;
     FDump.Assign(Source);
     CreateBitmap;
end;

//***********************************************
//**          CLEAR THE CLASS                  **
//***********************************************
procedure TBitmapDump.clear;
begin
     FImage.Width := 0;
     FImage.Height := 0;
     FDump.Clear;
end;

//**********************************************
//**        BITMAP DUMP CONSTRUCTOR           **
//**********************************************
constructor TBitmapDump.create;
begin
     inherited Create;
     FImage := TBitmap.Create;
     FDump := TStringList.Create;
end;

//**********************************************
//**       BITMAP DUMP CREATE A BITMAP        **
//**********************************************
procedure TBitmapDump.CreateBitmap;
var
   tb:TBitmap;
   ti:integer;
   ts:string;
   Buffer:PByteArray;

            Procedure StreamBuffer;
            var
               BufferData:TStringList;
               pixelsize:integer;
               buffersize:DWORD;
               y:integer;
               x:Dword;
               elements:integer;
               i:integer;
               es:string;
               bP:PByte;

                         procedure readPalette;
                         var
                            pal: PLogPalette;
                            hpal: HPALETTE;
                            pale:TagPaletteEntry;
                            tsl:Tstringlist;
                            x,y:integer;
                            i:integer;
                            ts:string;
                            pe:string;
                            entries:integer;
                            palb:Pbytearray;
                         begin

                              tsl:= ExtractProfileBlock(FDump,'DumpPallete','DumpPallete End');
                              stripblanklines(tsl);
                              GetMem(pal, sizeof(TLogPalette) + sizeof(TPaletteEntry) * 255);
                              pal^.palVersion := $300;
                              pal^.palNumEntries := 256;

                              palb := addr(pal^.palPalEntry);
                              //GetPaletteEntries(S.Palette,0,255,pal^.palpalentry);
                              i:=0;
                              if tsl.count > 0 then
                              for y:=0 to tsl.count - 1 do
                              begin
                                   ts:=chop(ExtractRemainderStop(tsl[y],1,';'),' ');
                                   if ts<>'' then
                                   begin
                                        entries := countsubstring(ts,',');
                                        if entries > 0 then
                                        for x := 0 to entries do
                                        begin
                                             pe := grabsubstring(ts,x,',');
                                             if not (isnumber(pe)) then pe :='0';
                                             if i < 1024 then palb[i] := strToint(pe);
                                             inc(i);
                                        end;//parse line

                                   end;//validate line

                              end;//scan lines

                              hpal := Createpalette(pal^);
                              tb.Palette := hpal;
                              Freemem(pal,sizeof(TLogPalette) + sizeof(TPaletteEntry) * 255);
                              tsl.free;
                         end;
                         procedure writebackdata;
                         var
                            x,y:integer;
                            row:pbytearray;
                            pb:PByte;
                            i:dword;
                         begin
                              i:=0;
                              for y := 0 to tb.Height -1 do
                              begin
                                   pb:=tb.ScanLine[y];
                                   for x := 0 to (tb.Width * pixelsize) - 1 do
                                   begin
                                        if i<= BufferSize Then pb^ := Buffer[i];
                                        inc(pb);
                                        inc(i);
                                   end;
                              end;

                         end;// write back data


                         FUNCTION _PixelSize(const pf:TpixelFormat):Word;
                         BEGIN
                              Result := 0;
                                   Case pf of
                                   pf8bit : result := 1;
                                   pf16bit :result := 2;
                                   pf24bit : result := 3;
                                   pf32bit :result := 4;
                                   pfdevice : BEGIN

                                              END;
                                   end;
                         END;
            begin
                    BufferData := ExtractProfileBlock(FDump,'DumpData','DumpData End');
                    StripBlankLines(BufferData);
                    if tb.PixelFormat = pf8bit then ReadPalette;
                    pixelsize := _PixelSize(tb.pixelformat);
                    BufferSize := tb.width * tb.height * pixelsize;
                    getmem(buffer,BufferSize);
                    bp:=Pointer(Buffer);
                    x:=0;
                    if BufferData.count > 0 then
                    for y := 0 to BufferData.count - 1 do
                    begin
                         ts:=chop(extractremainderstop(BufferData[y],1,';'),' ');
                         if ts <> '' then
                         begin
                              i:=1;
                              es := grabsubstring(ts,i,',');
                              while es<> '' do
                              begin
                                   if x <= BufferSize then bp^ := StrToInt(es);
                                   inc(bp);
                                   inc(x);
                                   inc(i);
                                   es := grabsubstring(ts,i,',');
                              end;// parse elements
                         end; // parse line
                    end;// loop through text lines

                    WriteBackData;
                    Freemem(Buffer,BufferSize);

                 BufferData.free;
            end;


begin
     {
      Create Temp Bitmap
             Load Width
             Set bitmap width
             Load Height
             Set Bitmap Height
             load pixel format
             set pixelformat
             Load Dump into Buffer
     }

     tb := TBitmap.Create;

     //Load and Set Width
     ts := getprofilevalue(Dump,'width','=',';');
     if not isnumber(ts) then
     begin
          application.MessageBox('Bitmap dump improperly formatted, no width value found','error',mb_ok);
          tb.free;
          exit;
     end; // invalid width value
     tb.Width := StrToInt(Ts);

     //Load and set Height
     ts := getprofilevalue(Dump,'height','=',';');
     if not isnumber(ts) then
     begin
          application.MessageBox('Bitmap dump improperly formatted, no height value found','error',mb_ok);
          tb.free;
          exit;
     end; // invalid width value
     tb.height := StrToInt(Ts);

     //Load and set the pixel format
     ts := getprofilevalue(Dump,'pixelformat','=',';');
     tb.PixelFormat := pixelformatstringTopixelformat(ts);

     StreamBuffer;
     FImage.Assign(tb);

     tb.free;
end;

//**********************************************
//**          BITMAP DUMP CREATE DUMP         **
//**********************************************
procedure TBitmapDump.CreateDump;
Var
   row:PByteArray;
   x,y:integer;
   ts:String;
   pal: PLogPalette;
   hpal: HPALETTE;
   pale:TagPaletteEntry;
   i:integer;
   pe:string;
   entries:integer;
   palb:Pbytearray;
Function PixelFormatToStr(pf:TpixelFormat):String;
Var
   ts:string;
BEGIN
    ts:='unknown';
    Case Pf of
    pfDevice : ts := 'Device Format';
    pf1bit : ts := '1 Bit';
    pf4bit  : ts := '4 Bit';
    pf8bit  : ts := '8 Bit';
    pf15bit  : ts := '15 Bit';
    pf16bit  : ts := '16 Bit';
    pf24bit  : ts := '24 Bit';
    pf32bit  : ts := '32 Bit';
    pfCustom  : ts := 'Custom';
   END ;
    PixelFormatToStr:=ts;
END;

FUNCTION PixelSize(const pf:TpixelFormat):Word;
BEGIN
     Result := 0;
     Case pf of
               pf8bit : result := 1;
               pf16bit :result := 2;
               pf24bit : result := 3;
               pf32bit :result := 4;
               pfdevice : BEGIN

                          END;
     end;
END;

begin
     FDump.add('width ='+Inttostr(Fimage.Width));
     FDump.Add('Height ='+inttostr(Fimage.Height));
     FDump.add('PixelFormat ='+PixelFormatToStr(FImage.Pixelformat));

     if Fimage.PixelFormat = pf8bit then
     begin
                            GetMem(pal, sizeof(TLogPalette) + sizeof(TPaletteEntry) * 255);
                            pal^.palVersion := $300;
                            pal^.palNumEntries := 256;
                            GetPaletteEntries(FImage.Palette,0,255,pal^.palpalentry);
                            palb := addr(pal^.palPalEntry[0].pered);
                            ts:='';
                            pale := pal^.PalPalEntry[0];
                            ts := inttostr(pale.peRed)+','+inttostr(pale.peGreen)+','+inttostr(pale.peBlue)+',';//for some reason
                            for i := 0 to 1023 do
                            begin
                                 ts:=ts+inttostr(palb[i]);
                                 if i<1023 then ts:=ts+',';
                            end;
                            FDump.add('[DumpPallete]');
                            FDump.add(ts);
                            FDump.add('[DumpPallete End]');


                            Freemem(pal,sizeof(TLogPalette) + sizeof(TPaletteEntry) * 255);
     end;

     FDump.add('[DumpData]');
     if FImage.height > 0 then
     for y := 0 to FImage.height - 1 do
     begin
          ts:='';
          row:=FImage.ScanLine[y];
          if FImage.Width > 0 then
          for x := 0 to (FImage.Width * PixelSize(Fimage.Pixelformat)) - 1 do
          begin
               ts:= ts +inttostr(row[x]);
               if x < (Fimage.width * PixelSize(Fimage.Pixelformat)) - 1 then ts := ts + ',';
          end;
          FDump.add(ts);
     end;
     FDump.add('[DumpData End]');
end;

//**********************************************
//**         DESTROY THE BITMAP DUMP          **
//**********************************************
destructor TBitmapDump.destroy;
begin
     Fimage.Free;
     Fdump.Free;
     inherited Destroy;
end;

{ TPageSplitter }
//*********************************************************************************************
//*********************************************************************************************
//*********************************************************************************************
//**                                                                                         **
//**                             TPAGE SPLITTER CONTROL                                      **
//**                                                                                         **
//*********************************************************************************************
//*********************************************************************************************
//*********************************************************************************************

//*********************************************************************************************
//**                     ABSOLUTE COMBINE PAGES                                              **
//*********************************************************************************************
function TPageSplitter.AbsoluteCombinePages(PageList: String): TStringList;
begin
     Result := TStringlist.create;
     AbsoluteCombinePages(PageList,Result);
end;// of Absolute Combine Pages

function TPageSplitter.AbsoluteCombinePages(PageList: String; var ToList: TStringList): Boolean;
// Version 1.0 Lachlan Fairgrieve
// Intialise & Validate:
//            ToList
//            Count the number of pages
// Process PageList :
//                   Get page number string & validate
//                   Get the page data for that page
//                   add that page data to [ToList]
var
   NoElements:Integer; // The Number of page numbers held within PageList
   TempList:TStringList;
   i:integer; // index to a [pagelist] item
   CurrentPageString:String;
   CurrentPage:Integer;
   Linei:integer;
begin
     //*****************************
     //**  INTIALISE  & VALIDATE  **
     //*****************************
     Result := False;
     if isbadwriteptr(ToList,4) then exit;
     ToList.Clear;
     if PageList = '' then exit;
     NoElements := CountSubString(PageList,',');
     if NoElements < 1 then exit;
     TempList := TStringList.create;
     //*********************************
     //**    PROCESS PAGELIST         **
     //*********************************
     for i := 1 to NoElements do
     begin
          CurrentPageString := chop(grabsubstring(PageList,i,','));
          if isnumber(CurrentPageString) then
          begin
               CurrentPage := StrToInt(CurrentPageString);
               TempList.Clear;
               GetPage(CurrentPage,IncludeBreakInCompiledPages,TempList);
               if TempList.Count > 0 then for linei := 0 to TempList.count - 1 do
               ToList.add(TempList[Linei]);
          end; // is the current page number string a valid number
     end;//PageList item scan
     Result := true;
     TempList.Free;
end; // of absolute combine pages

//**************************************************************************************
//**                 CLEAR PAGESPLITTER DATA                                          **
//**************************************************************************************
procedure TPageSplitter.clear;
var
   TSL:TStringList;
   i:integer;
begin
     if Pages.count > 0 then for i := 0 to Pages.Count - 1 do
     begin
          Tsl:=Pages[i];
          tsl.Free;
     end;
     Pages.Clear;
     FPageSeperator := #12;
     FIncludeBreakInCompiledPages := True;
end;

//***************************************************************************************
//**                        COMBINE PAGES                                              **
//***************************************************************************************
function TPageSplitter.CombinePages(PageString: String;var ToList: TStringList): Boolean;
// Version 1.0 Lachlan Fairgrieve
//  Initialise & Validate:
//                       [ToList]
//                       PageString + Count Number of elements
//  Parse Page String : For Every Element:
//                                        If IsNumber then Add else
//                                        Get Number Get Number 2 (Validate)
//                                        Add Elements in the range to RawList
//  Prepeare Result :
//                    Absolute Combine the RawList Pages = Result
//
var
   RawList:String; // The fully parse PageString
   NumberOfElements:Integer;
   i:integer;
   ElementString:String;
   No1S,No2S:String;
   No1,No2:integer;
   ti:integer;

begin
     //*******************************
     //**   INITIALISE & VALIDATE   **
     //*******************************
     result := False;
     if isbadwriteptr(ToList,4) then exit;
     ToList.Clear;
     RawList:='';
     if PageString = '' then exit;
     NumberOfElements := CountSubString(PageString,',');
     if NumberOfElements < 1 then exit;
     //********************************
     //**   PARSE PAGESTRING         **
     //********************************
     for i := 1 to NumberOfElements do
     begin
          ElementString := Chop(GrabSubString(PageString,i,','));
          if isnumber(ElementString) then
          begin
               RawList := RawList + ElementString+',';
          end
          else if CountSubString(ElementString,'.') > 0 then
          begin
               No1S := Chop(GrabSubString(ElementString,1,'.'));
               No2S := Chop(GrabSubString(ElementString,2,'.'));
               if IsNumber(No1S) and IsNumber(No2S) then
               begin
                    No1 := StrToInt(No1S);
                    No2 := StrToInt(No2S);

                    if No1 > No2 Then
                    begin
                         for ti := No1 downto No2 do
                            RawList := RawList + IntToStr(Ti)+',';
                    end ELSE
                         for ti := No1 to No2 do
                         RawList := RawList + IntToStr(Ti)+',';

               end ELSE
               Begin
                    // Error handling Here
               end;
          end Else
          begin
               // Error Handling Here
          end;

     end;//[PageString] element scan

     //******************************************************
     //**            PREPARE RESULT                        **
     //******************************************************
     Result := AbsoluteCombinePages(RawList,ToList);
end; // of combine pages

function TPageSplitter.CombinePages(PageString: String): TStringList;
begin
     Result := TStringList.Create;
     CombinePages(PageString,Result);
end;
//***************************************************************************************
//***************************************************************************************
//**                     COUNT THE PAGES                                               **
//***************************************************************************************
//***************************************************************************************
function TPageSplitter.CountPages: Integer;
begin
     Result := Pages.Count;
end;

//***************************************************************************************
//***************************************************************************************
//**                     CREATE THE PAGESPLITTER                                       **
//***************************************************************************************
//***************************************************************************************
constructor TPageSplitter.create;
begin
     inherited create;
     Pages := TList.Create;
     Clear;
end; // of PageSplitter.Create;
//***************************************************************************************
//***************************************************************************************
//**                    DESTROY THE PAGESPLITTER                                       **
//***************************************************************************************
//***************************************************************************************
destructor TPageSplitter.destroy;
begin
     Clear;
     pages.Free;
     inherited Destroy;
end;

//***************************************************************************************
//***************************************************************************************
//**                           GET A CHOSEN PAGE                                       **
//***************************************************************************************
//***************************************************************************************
function TPageSplitter.GetPage(PageNo: Integer): TStringList;
begin
     result := tstringlist.create;
     getpage(pageno,IncludeBreakInCompiledPages,result);
end;

function TPageSplitter.GetPage(PageNo: Integer; IncludeBreak: Boolean): TStringList;
begin
     result := TStringList.create;
     getpage(pageno,includebreak,result);
end;

function TPageSplitter.GetPage(PageNo: Integer; IncludeBreak: Boolean;var ToList: TStringList): Boolean;
// Version 1.0 Lachlan Fairgrieve
var
   tsl:TStringList;
   i:integer;
begin
     result := false;
     if isbadwriteptr(ToList,4) then exit;
     ToList.Clear;
     if pageno < 1 then exit;
     if includebreak then tolist.add(self.PageSeperator);
     if pageno > pages.Count then
     begin
          result := true;
          exit;
     end;
     tsl := pages[pageno -1];
     if tsl.count >  0 then
     for i := 0 to tsl.count -1 do tolist.add(tsl[i]);
     result := true;
end;


//***************************************************************************************
//***************************************************************************************
//**                    PARSE THE SOURCE DOCUMENT                                      **
//***************************************************************************************
//***************************************************************************************
procedure TPageSplitter.ParseSourceDocument(SourceFile: TFilename);
var
   tsl:Tstringlist;
begin
     tsl.LoadFromFile(sourcefile);
     parsesourcedocument(tsl);
     tsl.free;
end;

procedure TPageSplitter.ParseSourceDocument(Source: TStringList);
var
   CPage:TStringList; // Current Page Buffer
   CPageText:String;
   CPageNo:Integer;   // Current Page Number
   SourceS:String;     // Copy of the Source.Text
   Sourcei:integer;   // index in source.text
   SourceP:PCHAR;     // Pointer to source.text
   First:Boolean;     // Am I still on the first page
   i:integer;
begin

     CpageNo:=0;
     CPage := TStringList.Create;
     SourceI:=1;
     SourceS := Source.Text;
     SourceP := Pointer(SourceS);
     First := True;
     CPageText := '';


     if IsMaskAtPos(SourceP,1,FPageSeperator) then
     for i := 1 to length(FPageSeperator) do
     begin
          inc(SourceP);
          inc(SourceI);
     end;

     While SourceI <= Length(SourceS) do
     begin
          if IsMaskAtPos(SourceP,1,FPageSeperator) then
          begin
               CPage.Text := CPageText;
               Pages.Add(CPage);
               CPage := TStringList.Create;
               inc(CPageNo);
               for i := 1 to length(FPageSeperator) do
               begin
                    inc(SourceP);
                    inc(SourceI);
               end;
               CPageText := '';
          end else
          begin
               CPageText := CPageText + SourceP^;
               inc(SourceP);
               inc(SourceI);
          end;
     end;
     if CPageText<>'' then
     begin
          CPage.Text := CPageText;
          Pages.Add(CPage);
     end;
end;

INITIALIZATION
              _CountryList := TStringList.Create;
              With _CountryList do
              begin
                   Add('Afghanistan,AFG');
                   Add('Albania,ALB');
                   Add('Algeria,DZA');
                   Add('Angola,AGO');
                   Add('Antigua and Barbuda,ATG');
                   Add('Argentina,ARG');
                   Add('Australia,AUS');
                   Add('Austria,AUT');
                   Add('Bahamas The,BHS');
                   Add('Bahrain,BHR');
                   Add('Bangladesh,BGD');
                   Add('Barbados,BRB');
                   Add('Belgium,BEL');
                   Add('Belize,BLZ');
                   Add('Benin,BEN');
                   Add('Bermuda,BMU');
                   Add('Bhutan,BTN');
                   Add('Bolivia,BOL');
                   Add('Botswana,BWA');
                   Add('Brazil,BRA');
                   Add('Britain,GBR');
                   Add('Brunei,BRN');
                   Add('Bulgaria,BGR');
                   Add('Burma,BUR');                   
                   Add('Burkina Faso,MVO');
                   Add('Burundi,BDI');
                   Add('Cameroon,CMR');
                   Add('Canada,CAN');
                   Add('Cape Verde,CPV');
                   Add('Central African Rep.,CAF');
                   Add('Chad,TCD');
                   Add('Chile,CHL');
                   Add('China,CHN');
                   Add('CIS (Former USSR),CIS');
                   Add('Colombia,COL');
                   Add('Comoros,COM');
                   Add('Congo,COG');
                   Add('Costa Rica,CRI');
                   Add('Cuba,CUB');
                   Add('Cyprus,CYP');
                   Add('Czechoslovakia,CSK');
                   Add('Denmark,DNK');
                   Add('Djibouti,DJI');
                   Add('Dominica,DMA');
                   Add('Dominican Republic,DOM');
                   Add('Ecuador,ECU');
                   Add('Egypt,EGY');
                   Add('El Salvador,SLV');
                   Add('Equatorial Guinea,GNQ');
                   Add('Ethiopia,ETH');
                   Add('Fiji,FJI');
                   Add('Finland,FIN');
                   Add('France,FRA');
                   Add('French Polynesia,PYF');
                   Add('Gabon,GAB');
                   Add('Gambia The,GMB');
                   Add('Germany,DEU');
                   Add('Ghana,GHA');
                   Add('Greece,GRC');
                   Add('Greenland,GRL');
                   Add('Grenada,GRD');
                   Add('Guadeloupe,GLP');
                   Add('Guam,GUM');
                   Add('Guatemala,GTM');
                   Add('Guiana French,GUF');
                   Add('Guinea,GIN');
                   Add('Guinea Bissau,GNB');
                   Add('Guyana,GUY');
                   Add('Haiti,HTI');
                   Add('Honduras,HND');
                   Add('Hong Kong,HKG');
                   Add('Hungary,HUN');
                   Add('Iceland,ISL');
                   Add('India,IND');
                   Add('Indonesia,IDN');
                   Add('Iran I.R. of,IRN');
                   Add('IraqIRQ');
                   Add('Ireland,IRL');
                   Add('Israel,ISR');
                   Add('Italy,ITA');
                   Add('Ivory Coast,CIV');
                   Add('Jamaica,JAM');
                   Add('Japan,JPN');
                   Add('Jordan,JOR');
                   Add('Kampuchea Dem,KHM');
                   Add('Kenya,KEN');
                   Add('Kiribati Rep. of,KIR');
                   Add('Korea Republic of,KOR');
                   Add('Kuwait,KWT');
                   Add('Lao P. D. Rep,LAO');
                   Add('Lebanon,LBN');
                   Add('Lesotho,LSO');
                   Add('Liberia,LBR');
                   Add('Libya,LBY');
                   Add('Luxembourg,LUX');
                   Add('Macau,MAC');
                   Add('Madagascar,MDG');
                   Add('Malawi,MWI');
                   Add('Malaysia,MYS');
                   Add('Maldives,MDV');
                   Add('Mali,MLI');
                   Add('Malta,MLT');
                   Add('Martinique,MTQ');
                   Add('Mauritania,MRT');
                   Add('Mauritius,MUS');
                   Add('Mexico,MEX');
                   Add('Mongolia,MNG');
                   Add('Montserrat,MSR');
                   Add('Morocco,MAR');
                   Add('Mozambique,MOZ');
                   Add('N.Korea,PRK');
                   Add('Namibia,NAM');
                   Add('Nauru,NRU');
                   Add('Nepal,NPL');
                   Add('Netherlands,NLD');
                   Add('Netherlands Antilles,ANT');
                   Add('New Caledonia,NCL');
                   Add('New Zealand,NEZ');
                   Add('Nicaragua,NIC');
                   Add('Niger,NER');
                   Add('Nigeria,NGA');
                   Add('Norway,NOR');
                   Add('Oman,OMN');
                   Add('Pakistan,PAK');
                   Add('Panama,PAN');
                   Add('Papua New Guinea,PNG');
                   Add('Paraguay,PRY');
                   Add('Peru,PER');
                   Add('Phillippines,PHL');
                   Add('Poland,POL');
                   Add('Portugal,PRT');
                   Add('Qatar,QAT');
                   Add('Reunion,REU');
                   Add('Romania,ROM');
                   Add('Rwanda,RWA');
                   Add('Sao Tome & Principe,STP');
                   Add('Saudi Arabia,SAU');
                   Add('Senegal,SEN');
                   Add('Seychelles,SYC');
                   Add('Sierra Leona,SLE');
                   Add('Singapore,SGP');
                   Add('Solomon Islands,SLB');
                   Add('Somalia,SOM');
                   Add('South Africa,ZAF');
                   Add('Spain,ESP');
                   Add('Sri Lanka,LKA');
                   Add('St. Helena,SHN');
                   Add('St. Kitts&Nevis,KNA');
                   Add('St. Lucia,LCA');
                   Add('St. Pierre Miquelon,SPM');
                   Add('St. Vincent,VCT');
                   Add('Sudan,SDN');
                   Add('Suriname,SUR');
                   Add('Swaziland,SWZ');
                   Add('Sweden,SWE');
                   Add('Switzerland,CHE');
                   Add('Syrian Arab Rep,SYR');
                   Add('Taiwan (Province of),TWN');
                   Add('Tanzania,TZR');
                   Add('Thailand,THA');
                   Add('Togo,TGO');
                   Add('Tonga,TON');
                   Add('Trinidad and Tobago,TTO');
                   Add('Tunisia,TUN');
                   Add('Turkey,TUR');
                   Add('Tuvalu,TUV');
                   Add('Uganda,UGA');
                   Add('United Arab Emirates,ARE');
                   Add('United Kingdom,GBR');
                   Add('United States,USA');
                   Add('Uruguay,URY');
                   Add('Vanuatu,VUT');
                   Add('Venezuela,VEN');
                   Add('Viet Nam,VNM');
                   Add('Western Samoa,WSM');
                   Add('Yemen PDR,YMD');
                   Add('Yemen Rep,YEM');
                   Add('Yugoslavia,YUG');
                   Add('Zaire,ZAR');
                   Add('Zambia,ZMB');
                   Add('Zimbabwe,ZWE');
              end;

FINALIZATION
            _CountryList.Free;
            terminatethread(getcurrentthread(),0);
end.
